from __future__ import annotations

from collections.abc import Mapping
from typing import Any, TypeVar

from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

T = TypeVar("T", bound="PkgRoutesMiscEvaluateExpressionRequest")


@_attrs_define
class PkgRoutesMiscEvaluateExpressionRequest:
    """
    Attributes:
        context (str | Unset):
        expression (str | Unset):
        missing (str | Unset):
        prop (str | Unset):
        type_ (str | Unset):
    """

    context: str | Unset = UNSET
    expression: str | Unset = UNSET
    missing: str | Unset = UNSET
    prop: str | Unset = UNSET
    type_: str | Unset = UNSET
    additional_properties: dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> dict[str, Any]:
        context = self.context

        expression = self.expression

        missing = self.missing

        prop = self.prop

        type_ = self.type_

        field_dict: dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if context is not UNSET:
            field_dict["context"] = context
        if expression is not UNSET:
            field_dict["expression"] = expression
        if missing is not UNSET:
            field_dict["missing"] = missing
        if prop is not UNSET:
            field_dict["prop"] = prop
        if type_ is not UNSET:
            field_dict["type"] = type_

        return field_dict

    @classmethod
    def from_dict(cls: type[T], src_dict: Mapping[str, Any]) -> T:
        d = dict(src_dict)
        context = d.pop("context", UNSET)

        expression = d.pop("expression", UNSET)

        missing = d.pop("missing", UNSET)

        prop = d.pop("prop", UNSET)

        type_ = d.pop("type", UNSET)

        pkg_routes_misc_evaluate_expression_request = cls(
            context=context,
            expression=expression,
            missing=missing,
            prop=prop,
            type_=type_,
        )

        pkg_routes_misc_evaluate_expression_request.additional_properties = d
        return pkg_routes_misc_evaluate_expression_request

    @property
    def additional_keys(self) -> list[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
